// Copyright (c) 2012, Ladislav Thon. All rights reserved. Use of this source
// code is governed by a BSD-style license that can be found in the LICENSE file.

library matchers;

import 'dart:math';
import 'package:dartlings/strings.dart';

part 'src/matchers/predicates.dart';
part 'src/matchers/base_matchers.dart';
part 'src/matchers/compound_matchers.dart';
part 'src/matchers/bool_matchers.dart';
part 'src/matchers/string_matchers.dart';
part 'src/matchers/num_matchers.dart';
part 'src/matchers/int_matchers.dart';
part 'src/matchers/collection_matchers.dart';
part 'src/matchers/map_matchers.dart';
part 'src/matchers/invocation_matchers.dart';
part 'src/matchers/type_matchers.dart';

part 'src/matchers/list_diff.dart';

/// [Matcher] is a predicate that either holds or doesn't hold for given value.
/// We either say that the value matches or that it doesn't match. Matcher can
/// also describe the predicate in a human-readable way.
class Matcher<T> {
  bool matches(T value);
  String get description;
}

/// Matchers that implement this interface can provide better [String]
/// representation of a difference between expected and actual object.
class HasRichMessage<T> {
  String buildMessage(T value);
}
